
static char police9x15[9]= "9x15bold";
static int lgpolice9x15 = 10; // size(police9x15)+1

static Widget make_label(char *nom, Widget pere, int h)
{
  Widget w;
  w = XtVaCreateManagedWidget(nom, xmLabelWidgetClass, pere,
			      XmNlabelString, XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET), 
			      XmNwidth, LABEL_WIDTH, XmNheight, h, 
			      NULL);
  //  XtVaSetValues(w, XtVaTypedArg, XmNfontList, XmRString, police9x15, lgpolice9x15, NULL);
  return w;
}

static Widget make_button(char *nom, Widget pere, int bordWidth)
{
  return(XtVaCreateManagedWidget(nom, xmPushButtonWidgetClass, pere, XmNwidth, BUTTON_WIDTH,
				 XmNborderWidth, bordWidth, XmNlabelString, 
				XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET), NULL));
}

static Widget make_jauge(char *nom, Widget pere, int min, int max)
{
  return(XtVaCreateManagedWidget(nom, xmScaleWidgetClass, pere, XmNtitleString, 
				 XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET),
				 XmNminimum, min, XmNmaximum, max, XmNshowValue, true, 
				 XmNorientation, XmHORIZONTAL, XmNscaleHeight, 40, 
				 XmNscaleWidth, 200, NULL));
}

static void creation_pace_rhythm(Widget w)
{
  Widget     t_widg, widg1, widg2, widg3, widg4, canvas_widg;

  canvas_widg = XtVaCreateManagedWidget("meter_pace", xmDrawingAreaWidgetClass, w, 
					XmNborderWidth, 0, XmNwidth, 180, XmNheight, 25 /*45 */, 
					XmNtopAttachment, XmATTACH_FORM, 
					XmNbottomAttachment, XmATTACH_FORM, NULL);
  meter_pace_creat(canvas_widg);
  widg1 = make_button("+", w, 2);
  XtVaSetValues(widg1,  XmNheight, BUTTON_HEIGHT_PACE, XmNtopAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, canvas_widg, NULL);
  XtAddCallback(widg1, XmNactivateCallback, (XtCallbackProc)inter_pace_up_p, NULL);

  widg2 = make_button("-", w, 2);
  XtAddCallback(widg2, XmNactivateCallback, (XtCallbackProc)inter_auto, NULL);
  XtVaSetValues(widg2,  XmNheight, BUTTON_HEIGHT_PACE, XmNtopAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		  XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, widg1, NULL);
  XtAddCallback(widg2, XmNactivateCallback, (XtCallbackProc)inter_pace_down_p, NULL);

  widg3 = make_button("/", w, 2);
  XtVaSetValues(widg3,  XmNheight, BUTTON_HEIGHT_PACE , XmNtopAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_WIDGET,  XmNleftWidget, widg2 , NULL);
  XtAddCallback(widg3, XmNactivateCallback, (XtCallbackProc)inter_pace_down_m, NULL);

  widg4 = make_button("*", w, 2);
  XtVaSetValues(widg4,  XmNheight, BUTTON_HEIGHT_PACE, XmNtopAttachment, XmATTACH_FORM,
		XmNbottomAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, widg3 , NULL);
  XtAddCallback(widg4, XmNactivateCallback, (XtCallbackProc)inter_pace_up_m, NULL);
}


static void creation_pace_control(Widget w)
{
  Widget t_widg, widg;

  t_widg = make_button("TICK", w, 2);
  XtVaSetValues(t_widg,  XmNheight, BUTTON_HEIGHT_C, XmNtopAttachment, XmATTACH_FORM,
		XmNrightAttachment, XmATTACH_FORM, NULL);
  XtAddCallback(t_widg, XmNactivateCallback, (XtCallbackProc)inter_tick, NULL);

  widg = make_button("AUTO", w, 2);
  XtVaSetValues(widg,  XmNheight, BUTTON_HEIGHT_C, XmNtopAttachment, XmATTACH_FORM,
		XmNrightAttachment, XmATTACH_WIDGET, XmNrightWidget, t_widg, NULL);
  XtAddCallback(widg, XmNactivateCallback, (XtCallbackProc)inter_auto, NULL);
  auto_creat(widg);

  widg = make_button("QUIT", w, 2);
  XtVaSetValues(widg,  XmNheight, BUTTON_HEIGHT_C, XmNtopAttachment, XmATTACH_FORM,
		XmNleftAttachment, XmATTACH_FORM, NULL);
  XtAddCallback(widg, XmNactivateCallback, (XtCallbackProc)inter_stop, NULL);
  stop_creat(widg);
}


static void creation_pace_maker(Widget w)
{
  Widget  control_widg, rhythm_widg;

  rhythm_widg = XtVaCreateManagedWidget("pace_rhythm", xmFormWidgetClass, w, 
					XmNborderWidth, 1,
					XmNtopAttachment, XmATTACH_FORM, 
					XmNrightAttachment, XmATTACH_FORM,
					XmNleftAttachment, XmATTACH_FORM,
					NULL);
  creation_pace_rhythm(rhythm_widg);
  control_widg = XtVaCreateManagedWidget("pace_control", xmFormWidgetClass, w, 
					 XmNrightAttachment, XmATTACH_FORM,
					 XmNleftAttachment, XmATTACH_FORM,
					 XmNtopAttachment, XmATTACH_WIDGET,
					 XmNtopWidget, rhythm_widg,
					 NULL);
  creation_pace_control(control_widg);
}


static void creation_panel_gauche(Widget pere)
{
  Widget    w1, w2, w3, w4, w5, w6;

  //  XtVaSetValues(pere, XtVaTypedArg, XmNfontList, XmRString, police9x15, lgpolice9x15, NULL);
  w1 = make_label("POSITION_INDICATOR", pere, BUTTON_HEIGHT);
  XtVaSetValues(w1, XmNtopAttachment, XmATTACH_FORM,
		XmNleftAttachment,  XmATTACH_FORM, XmNrightAttachment,  XmATTACH_FORM, NULL);

  w2 = make_label("ACTIVE BLOCK", pere, BUTTON_HEIGHT);
  XtVaSetValues(w2, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w1,
		XmNleftAttachment,  XmATTACH_FORM, XmNrightAttachment,  XmATTACH_FORM, NULL);
  
  w3 = make_label("FUEL_INDICATOR", pere, BUTTON_HEIGHT);
  XtVaSetValues(w3, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w2,
		XmNleftAttachment,  XmATTACH_FORM, XmNrightAttachment,  XmATTACH_FORM, NULL);
  
  w4 = make_label("ACTIVE BLOCK", pere, BUTTON_HEIGHT);
  XtVaSetValues(w4, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w3, NULL);


  w5 = make_label("PARAMETER_REFRESHER", pere, BUTTON_HEIGHT);
  XtVaSetValues(w5, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w4, NULL);
  
  w6 = make_label("ACTIVE BLOCK", pere, BUTTON_HEIGHT);
  XtVaSetValues(w6, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, w5,
		XmNleftAttachment,  XmATTACH_FORM, XmNrightAttachment,  XmATTACH_FORM, NULL);

}

static void creation_input_panel(Widget pere)
{
  Widget w1, w2, w3;

  w1 = make_jauge("ACTIVE PARTITION ID    ",pere, MIN_A, MAX_A );
  XtVaSetValues(w1, XmNtopAttachment, XmATTACH_FORM, XmNleftAttachment, XmATTACH_FORM, NULL);
  XtAddCallback(w1, XmNdragCallback, (XtCallbackProc)inter_set_iPartition, NULL);
 
}

static void creation_id(Widget w)
{
  Widget panel_cadre, panel_gauche_widg, widg, panel_input_widg;

  panel_cadre = XtVaCreateManagedWidget("panel_cadre", xmFormWidgetClass, w, 
					      XmNtopAttachment, XmATTACH_FORM, 
					      XmNverticalSpacing, ESP_HEIGHT, 
					NULL);

  panel_gauche_widg = XtVaCreateManagedWidget("panel_gauche", xmFormWidgetClass, panel_cadre,
					      XmNborderWidth, 1,
					      XmNtopAttachment, XmATTACH_FORM,
					      XmNbottomAttachment,  XmATTACH_FORM,
					      XmNverticalSpacing, ESP_HEIGHT,
					      NULL);
  creation_panel_gauche(panel_gauche_widg);
  widg = XtVaCreateManagedWidget("canvas", xmDrawingAreaWidgetClass, panel_cadre, 
				 XmNborderWidth, 1, XmNwidth, CANVAS_WIDTH, 
				 XmNheight, CANVAS_HEIGHT, XmNtopAttachment, XmATTACH_FORM,
				 XmNbottomAttachment,  XmATTACH_FORM,
				 XmNleftAttachment, XmATTACH_WIDGET, 
				 XmNleftWidget, panel_gauche_widg,
				 NULL);
  canvas_creat(widg);
  panel_input_widg =  XtVaCreateManagedWidget("panel_input", xmFormWidgetClass, w, 
					      XmNtopAttachment,  XmATTACH_WIDGET, 
					      XmNtopWidget, panel_cadre,
					      XmNleftAttachment,  XmATTACH_FORM,
					      NULL);
  creation_input_panel(panel_input_widg);
}



/*------------------------------------------------------------------------------
     Creation de la fenetre principale :Pace maker + clim
 ------------------------------------------------------------------------------*/
static void creation_fenetre_principale(Widget toplevel)
{
  Widget pace_maker_widg, appli_widg, cadre_widg, frame_widg;

  cadre_widg = XtVaCreateManagedWidget("cadre", xmMainWindowWidgetClass, toplevel, NULL);
  frame_widg = XtVaCreateManagedWidget("frame", xmFormWidgetClass, cadre_widg, NULL);
  appli_widg = XtVaCreateManagedWidget(PROGNAME, xmFormWidgetClass, frame_widg, 
				      XmNtopAttachment,  XmATTACH_FORM, 
				      XmNleftAttachment, XmATTACH_FORM, 
				      XmNrightAttachment, XmATTACH_FORM, NULL);
  creation_id(appli_widg);

  pace_maker_widg = XtVaCreateManagedWidget("pace_maker", xmFormWidgetClass, frame_widg, 
					    XmNleftAttachment, XmATTACH_FORM, 
					    XmNtopAttachment, XmATTACH_WIDGET, 
					    XmNtopWidget, appli_widg, 
					    XmNbottomAttachment, XmATTACH_FORM, NULL);
  creation_pace_maker(pace_maker_widg);
}












