#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "ranlib.h"
#include "random.h"




/*==========================================================*/ 
/*                    ATTENTION                             */
/*==========================================================*/ 
/* verifier dans les sources (difficile car C + pointeurs ) */
/* si les entrees que l'on fournit ici sont les bonnes      */
/*   ----> meanv et covm ont il la bonne configuration      */
/*==========================================================*/ 


/********************************************************
  simulation d'une UNIFORME 
  *******************************************************/

/********************************************************
     initialisation du generateur 
  *******************************************************/
void INIT_GENERATEUR(int par_defaut, int seed1, int seed2)
{
 if (par_defaut != 0) setall((long)seed1,(long)seed2);
}

float  uniforme(int numgen,float borne_inf,float borne_sup)
/*********************************/      
 
{ 
  float result;
  gscgn(1,&numgen);
  result = genunf(borne_inf,borne_sup);
  
  return(result);
}


/********************************************************
  simulation d'une V.A UNIFORMENENT DISTRIBUEE SUR (A,...,B)
  *******************************************************/

extern int UNIFORME_INT(int numgen,int A,int B)
/*********************************/      
 
{ 
  long result;
  
  gscgn(1,&numgen);
  result = ignuin((long) A, (long) B);
  return((int) result);
  
}

void afficher_erreur2()
{
 printf("WARNING: gaussienne 2d => puissance active negative  (remplacee par 0) !!!\n");
}

/********************************************************
  simulation d'une gaussienne bi-dimensionnelle
  *******************************************************/
/*  !!!!!!!   VERIFIER SI IL S'AGIT BIEN DES BONS PARAMETRES  !!!!!!!! */ 

extern void GAUSS2D(int numgen,float mean1,float mean2,float var1,float var2 ,float cov,float *x1,float *x2)
 
{
  float meanv [2];
  float covm [2][2];
  long p;
  float parm[10],x[2],work[10];

  p = 2;
  meanv[0] = mean1;
  meanv[1] = mean2;
  covm[0][0] = var1;
  covm[1][1] = var2;
  covm[0][1] = cov;
  covm[1][0] = cov;
  gscgn(1,&numgen);
  setgmn(meanv,*covm,p,parm);
  genmn(parm,x,work);
  if (x[0]<0.0) *x1 = 0.0;
  else *x1= x[0];
  *x2= x[1];
  if (x[0]<0.0) afficher_erreur2();
}    

/********************************************************
  simulation d'une rayleight 
  par la inversion de la fonction de repartition
  a partir d'une loi uniforme sur [0,1]
*******************************************************/  
float rayleight(int numgen,float a)
{
  float u;
  float result;
  gscgn(1,&numgen);
  u = ranf();
  result = sqrt(a*a - 2*log(u));
  return(result);
}
  
/********************************************************
  simulation d'une weibull
  par inversion de la fonction de repartition 
  a partir d'une loi exponentielle de moyenne a
*******************************************************/
float weibull(int numgen,float a)
{
  float x;
  float result;
gscgn(1,&numgen);
  x = genexp(1.0);
  result = pow(x,1/a);
  return(result);
}

/********************************************************
  simulation loi normale N(mu,sigma2)

  mu     : moyenne (mean)
  sigma2 : Variance (standart deviation)
*******************************************************/


float gaussienne(int numgen,float mu,float sigma2)
{
  float result;
gscgn(1,&numgen);
  result = gennor(mu,sigma2);
  return(result);
}



/********************************************************
  simulation d'une INVERSE GAUSSIENNE  d'apres la methode
  de MICHAEL, SCHUCANY et HAAS cf
               " NON-UNIFORM RANDOM VARIATE GENERATION "
	       Luc Devroye (1986)
	       62E/DEV
	       18146
	       tour de math
  
  voir aussi l,exercice 3.21 page 94 de 
               " STOCHASTIC SIMULATION "
	       Briand D.Ripley
	       62 E 25/RIP
	       17675
	       tour de math
                       ----> CHERCHER L'ERREUR  !!!!!!!	       
	       
*******************************************************/ 	       


float inverse_gaussienne(int numgen1,int numgen2,float lambda,float mu)
/*******************************/ 
 

{
  float v,x1,u,x2;
  gscgn(1,&numgen1);
  v  = genchi(1.0); /* genchi rend un float */ 
  x1 = mu + (mu*mu*v - mu*sqrt(mu*mu*v*v + 4*mu*lambda*v))/(2*lambda);
  x2 = mu*mu/x1; /* x1 et x2 sont les deux racines */
  gscgn(1,&numgen2);
   u = ranf();
  if ( u <(mu/(mu+x1))) /* tirage uniforme */
    {
      return(x1);
    }
  else
    {
      return(x2);
    }
}









