
#include "coins_nb.h"

static Widget coins_back_title_widget,  coins_back_label_widget[COINS_DIFF], take_button_widget;

void coins_back_InitStrings()
{
  int i,j,l;
  char * s;
  l=0;
  for (i=0;i<COINS_DIFF;i++)
    if (strlen(COINS_STRINGS[i])>l) l = strlen(COINS_STRINGS[i]);
  
  for (i=0;i<COINS_DIFF;i++)
      {
	ALIGNED_COINS_STRINGS[i] = (char *)malloc(l+1);
	ALIGNED_COINS_STRINGS[i][0]='\0';
	for (j=0;j<l-strlen(COINS_STRINGS[i]);j++) strcat(ALIGNED_COINS_STRINGS[i]," ");
	strcat(ALIGNED_COINS_STRINGS[i],COINS_STRINGS[i]);
      }
}

/*=========================================================*/
/*        WIDGET  managing (saving)                        */
/*=========================================================*/

void create_coins_back_title(Widget widget)
{ coins_back_title_widget = widget; }

void create_take( Widget widget)
{ take_button_widget = widget; }

/*=========================================================*/
/*        READINGS                                         */
/*=========================================================*/

logical vtake;

void init_take()
{ vtake = FALSE; }

int SCAN_TAKE()
{
  logical take;
  take = vtake; 
  init_take(); 
  return take;
}

void push_take()
{  vtake = TRUE; }

void INIT_COINS_BACK_INPUTS(logical h)
{ 
  init_take(); 
}

/*=========================================================*/
/*        PRINTING                                         */
/*=========================================================*/

#define MAX_COINS 31

static void print_one_coin_back_on_widget(Widget w, int coins_nb, int coin_num)
{ 
  char s[1024];
  int i;

  if (coins_nb<0)
    sprintf(s,"%s%s %d", ALIGNED_COINS_STRINGS[coin_num], TWO_POINTS_STRING, coins_nb);
  else
    {
      sprintf(s,"%s%s ", ALIGNED_COINS_STRINGS[coin_num], TWO_POINTS_STRING);
      for (i=0;(i<MAX_COINS)&&(i<coins_nb);i++)	strcat(s,"o");
      if (coins_nb>MAX_COINS) strcat(s,"...");
    }
  //  if (s[0]=='0') s[0]=' ';
  putlabel(w,s);
}


void PRINT_ONE_COIN_BACK(int coins_nb, int coin_num)
{
  print_one_coin_back_on_widget(coins_back_label_widget[coin_num /*-1*/],coins_nb,coin_num /* -1 */);
}


/*=========================================================*/
/*        INITIALISATING                                   */
/*=========================================================*/

void COINS_BACK_INIT_LABELS()
{
  /*
    putlabel(coins_back_title_widget,COINS_BACK_TITLE);
    putlabel(take_button_widget,TAKE_STRING);
  */
}

/*=========================================================*/
/*        CALLBACKS SAVING                                 */
/*=========================================================*/

XtPointer coins_back_label_create_funcs[COINS_DIFF];
CallBackName coins_back_label_create_str[COINS_DIFF];

#define DEFINE_COIN(i)                                                  \
void create_coin_back_##i##_label(widget,client_data,call_data)         \
     Widget widget; caddr_t client_data,call_data;                      \
{                                                                       \
  coins_back_label_widget[i-1] = widget; \
  XtVaSetValues(widget, XmNbackground, greenColor, NULL); \
}

#define REGISTER_COIN(i) \
{                                                                            \
  sprintf(coins_back_label_create_str[ i -1],"create_coin_back_%d_label", i );   \
  coins_back_label_create_funcs[ i -1 ]=create_coin_back_##i##_label;           \
}

#define REGISTER_COINS    coins_back_RegisterCoins

#include "coins_def.h"

