#define BUTTON_HEIGHT 30
#define BUTTON_HEIGHT_PACE 15
#define BUTTON_HEIGHT_C 20
#define ESP_HEIGHT 20
#define LABEL_WIDTH 60
#define BUTTON_WIDTH 70

static Widget widg_A, widg_B, widg_C, widg_X1, widg_X2, widg_ERR, widg_jauge;
static char *str_A, *str_B, *str_C;
//  Gestion des couleurs
static Pixel def_col, red_col, blue_col, white_col, gray_col, black_col;
char *red = "red";
char *blue = "blue";
char *white = "white";
char *gray = "gray";
char *black = "black";

boolean no_communication = true; // a vrai tant que le prog. Signal n'a pas fait d'critures
int     nb_steps;  // nbre de steps qu'il faut au prog. Signal pour calculer les racines


static void afficher_jauge(Widget w, int val)
{
  XmScaleSetValue(w, val);
}


static modif_label(Widget w, char *str)
{
  XtVaSetValues(w, XmNlabelString , XmStringCreateLtoR(str, XmSTRING_DEFAULT_CHARSET), NULL);
}


// Call-back appele lorsqu'on clique sur le bouton "GO"
static void ok_reset(Widget widget, caddr_t client_data, caddr_t call_data)
{
  // on blanchit les entres
 XtVaSetValues(widg_A, XmNbackground, white_col, NULL);
 XtVaSetValues(widg_B, XmNbackground, white_col, NULL);
 XtVaSetValues(widg_C, XmNbackground, white_col, NULL);
 XmTextSetString(widg_A, "");
 XmTextSetString(widg_B, "");
 XmTextSetString(widg_C, "");
 str_A = "";
 str_B = "";
 str_C = "";
 // on noircit les sorties et on enlve le texte
 XtVaSetValues(widg_X1, XmNbackground, black_col, XmNforeground, black_col, NULL);
 XtVaSetValues(widg_X2, XmNbackground, black_col, XmNforeground, black_col, NULL);
 XmTextSetString(widg_X1, "");
 XmTextSetString(widg_X2, "");
 modif_label(widg_ERR, "           ");

 no_communication = true;
 nb_steps = 0;
 afficher_jauge(widg_jauge, nb_steps);
}


// Call-back appele lorsqu'on clique sur le bouton "GO"
static void ok_go(Widget widget, caddr_t client_data, caddr_t call_data)
{
  // on rcupre les valeurs des entres
 str_A = XmTextGetString(widg_A);
 str_B = XmTextGetString(widg_B);
 str_C = XmTextGetString(widg_C);
 // on noircit les sorties et on enlve le texte
 XtVaSetValues(widg_X1, XmNbackground, black_col, XmNforeground, black_col, NULL);
 XtVaSetValues(widg_X2, XmNbackground, black_col, XmNforeground, black_col, NULL);
 XmTextSetString(widg_X1, "");
 XmTextSetString(widg_X2, "");
 modif_label(widg_ERR, "           ");

 no_communication = true;
 nb_steps = 1;
 afficher_jauge(widg_jauge, nb_steps);

 // Signal iterating
 equationSolving_step();
 while (no_communication) 
   {
     nb_steps ++;
     afficher_jauge(widg_jauge, nb_steps);
     equationSolving_step();
   }

 XtFree(str_A);
 XtFree(str_B);
 XtFree(str_C);
}

// Call-back appele lorsqu'on clique sur le bouton "END"
static void ok_end(Widget widget, caddr_t client_data, caddr_t call_data)
{
     exit(0);
}


extern Pixel getColor(Widget widg, char *col)
{
  XrmValue from, to;
  from.size = strlen(col) +1;
  if (from.size < sizeof(String))
    from.size = sizeof(String);
  from.addr = col;
  to.addr = NULL;
  XtConvert(widg, XmRString, &from, XmRPixel, &to);
  return((Pixel) *((Pixel *)to.addr));
}


static Widget creer_label(char *nom, Widget pere)
{
  return(XtVaCreateManagedWidget(nom, xmLabelWidgetClass, pere,
				 XmNlabelString, XmStringCreateLtoR(nom, 
								    XmSTRING_DEFAULT_CHARSET), 
				 XmNwidth, LABEL_WIDTH, XmNheight, BUTTON_HEIGHT, 
				 XmNbackground, gray_col, XmNforeground, red_col, 
				 NULL));
}


static Widget creer_bouton(char *nom, Widget pere)
{
  return(XtVaCreateManagedWidget(nom, xmPushButtonWidgetClass, pere, XmNwidth, BUTTON_WIDTH,
			      XmNborderWidth, 2, XmNlabelString, 
			      XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET),
			      XmNbackground, blue_col, XmNforeground, white_col, NULL));
}

static Widget creer_jauge(char *nom, Widget pere, int min, int max)
{
  return(XtVaCreateManagedWidget(nom, xmScaleWidgetClass, pere, XmNtitleString, 
				 XmStringCreateLtoR(nom, XmSTRING_DEFAULT_CHARSET),
				 XmNminimum, min, XmNmaximum, max, XmNshowValue, true, 
				 XmNorientation, XmHORIZONTAL, XmNscaleHeight, 30, NULL));
}


static Widget creer_texte(char *nom, Widget pere)
{
  Widget w;
  w = (XtVaCreateManagedWidget(nom, xmTextWidgetClass, pere, XmNeditable, true, 
			       XmNeditMode, XmSINGLE_LINE_EDIT,
			       XmNborderWidth, 2, XmNcolumns, 11,
			       XmNbackground, white_col, NULL));
  return(w);
}



static void creation_panel_entrees(Widget w)
{
  Widget    w1, w2, titre, entrees_widg;

  titre = XtVaCreateManagedWidget
    ("lab", xmLabelWidgetClass, w,
     XmNlabelString, 
     XmStringCreateLtoR(" SOLVING for X THE EQUATION AX2 + BX + C = 0 WITH :",  XmSTRING_DEFAULT_CHARSET), 
     XmNheight, BUTTON_HEIGHT, 
     XmNbackground, gray_col, NULL);

  XtVaSetValues(titre, XmNtopAttachment, XmATTACH_FORM, NULL);

  entrees_widg = XtVaCreateManagedWidget("entrees", xmFormWidgetClass, w,
					 XmNtopAttachment, XmATTACH_WIDGET,
					 XmNtopWidget, titre, 
					 XmNverticalSpacing, ESP_HEIGHT, 
					 XmNbackground, gray_col, NULL);
  w1 = creer_label("A =", entrees_widg);
  XtVaSetValues(w1, XmNleftAttachment, XmATTACH_FORM, NULL);
  widg_A = creer_texte("text", entrees_widg);
  XtVaSetValues(widg_A, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget,w1, NULL);

  w1 = creer_label("B =", entrees_widg);
  XtVaSetValues(w1, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, widg_A, NULL);
  widg_B = creer_texte("text", entrees_widg);
  XtVaSetValues( widg_B, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w1, NULL);

  w1 = creer_label("C =", entrees_widg);
  XtVaSetValues(w1, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget,  widg_B, NULL);
  widg_C = creer_texte("text", entrees_widg);
  XtVaSetValues(widg_C, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w1, NULL);

  w1 = creer_label("    ", entrees_widg); /* pour mettre un espace */
  XtVaSetValues(w1, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, widg_C, NULL);
  w2 = creer_bouton(" RESET ", entrees_widg);
  XtVaSetValues(w2, XmNheight, 30,  XmNtopAttachment, XmATTACH_FORM, 
		XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w1, NULL);
  XtAddCallback(w2, XmNactivateCallback, ok_reset, NULL);

  w1 = creer_bouton(" GO ", entrees_widg);
  XtVaSetValues(w1, XmNheight, 30,  XmNtopAttachment, XmATTACH_FORM, 
		XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w2, NULL);
  XtAddCallback(w1, XmNactivateCallback, ok_go, NULL);

  w2 = creer_bouton(" END ", entrees_widg);
  XtVaSetValues(w2, XmNheight, 30,  XmNtopAttachment, XmATTACH_FORM, 
		XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w1, 
		NULL);
  XtAddCallback(w2, XmNactivateCallback, ok_end, NULL);
  w1 = creer_label("    ", entrees_widg); /* pour mettre un espace */
  XtVaSetValues(w1, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w2, NULL);
}


static void creation_panel_sorties(Widget w)
{
  Widget   w1, w2, titre, sorties_widg;;
  
titre = XtVaCreateManagedWidget
  ("lab", xmLabelWidgetClass, w,
   XmNlabelString, 
   XmStringCreateLtoR("    RESULTS :",  XmSTRING_DEFAULT_CHARSET), 
   XmNheight, BUTTON_HEIGHT, 
   XmNbackground,  gray_col, NULL
   );
 
  XtVaSetValues(titre, XmNtopAttachment, XmATTACH_FORM, NULL);

  sorties_widg = XtVaCreateManagedWidget("sorties", xmFormWidgetClass, w,
					 XmNtopAttachment, XmATTACH_WIDGET,
					 XmNtopWidget, titre, 
					 XmNverticalSpacing, ESP_HEIGHT, 
					 XmNbackground, gray_col, NULL);
  w1 = creer_label("X1 =", sorties_widg);
  XtVaSetValues(w1, XmNleftAttachment, XmATTACH_FORM, NULL);
  widg_X1 = creer_texte("text", sorties_widg);
  XtVaSetValues(widg_X1, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w1, NULL);

  w1 = creer_label("X2 =", sorties_widg);
  XtVaSetValues(w1, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, widg_X1, NULL);
  widg_X2 = creer_texte("text", sorties_widg);
  XtVaSetValues(widg_X2, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w1, NULL);

  w1 = creer_label("    ", sorties_widg);
  XtVaSetValues(w1, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, widg_X2, NULL);
  widg_ERR = creer_label("  ", sorties_widg);
  XtVaSetValues(widg_ERR, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w1, NULL);

  w1 = creer_label("    ", sorties_widg); /* pour mettre un espace */
  XtVaSetValues(w1, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, widg_ERR, NULL);
  w2 = creer_label("    ", sorties_widg); /* pour mettre un espace */
  XtVaSetValues(w2, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w1, NULL);

  widg_jauge = creer_jauge("STEP NUMBERS", sorties_widg, 0, 20);
  XtVaSetValues(widg_jauge, XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, w2, 
		XmNbackground, gray_col, NULL);
}


/*------------------------------------------------------------------------------
     Creation de la fenetre principale
 ------------------------------------------------------------------------------*/
static void creation_fenetre_principale(Widget toplevel)
{
  Widget cadre_widg, frame_widg, panel_entrees_widg, panel_sorties_widg;

  cadre_widg = XtVaCreateManagedWidget("cadre", xmMainWindowWidgetClass, toplevel, NULL);

  red_col = getColor(toplevel, red);
  blue_col = getColor(toplevel, blue);
  gray_col = getColor(toplevel, gray);
  white_col = getColor(toplevel, white);
  black_col = getColor(toplevel, black);

  frame_widg = XtVaCreateManagedWidget("frame", xmFormWidgetClass, cadre_widg, 
				       XmNtopAttachment,  XmATTACH_FORM, 
				      XmNleftAttachment, XmATTACH_FORM, 
				      XmNrightAttachment, XmATTACH_FORM, 
				       XmNbackground, gray_col, NULL);
  panel_entrees_widg = XtVaCreateManagedWidget("panel_entrees", xmFormWidgetClass, frame_widg, 
					      XmNtopAttachment, XmATTACH_FORM, 
					      XmNverticalSpacing, ESP_HEIGHT, 
					       XmNbackground, gray_col,NULL);
  creation_panel_entrees(panel_entrees_widg);

  panel_sorties_widg = XtVaCreateManagedWidget("panel_sorties", xmFormWidgetClass, frame_widg, 
					        XmNverticalSpacing, ESP_HEIGHT, 
					       XmNverticalSpacing, 10,
					       XmNleftAttachment,  XmATTACH_FORM,
					       XmNtopAttachment, XmATTACH_WIDGET,
					       XmNtopWidget, panel_entrees_widg, 
					       XmNverticalSpacing, ESP_HEIGHT, 
					       XmNbackground, gray_col, NULL);
  creation_panel_sorties(panel_sorties_widg);


}
