
/*
  Generated by Polychrony version  V4.19
*/
#include "equationSolving_types.h"
#include "equationSolving_externals.h"
#include "equationSolving_body.h"

/*  ==> parameters and indexes */
/*  ==> input signals     */
static float a, b, c;
/*  ==> output signals    */
static float x2, x1;
static boolean oc;
/*  ==> local signals     */
static boolean err2;
static float a1;
static boolean OK, stable;
static float bb, dd;
static boolean biterate;
static float next_yy, yy, mx, pre_next_yy;
static boolean next_stable;
static float XZX_158, s;
static boolean C_x1, OK_262, C_bb, C_err2, C_err2_269, C_bb1, C_bb1_278, C_d, C_d_289, C_x2, C_x2_300, C_err1, C_err1_308, C_a1, C_oc, C_x1_338;

EXTERN boolean equationSolving_initialize()
{
    stable = TRUE;
    bb = 0.0e0;
    mx = 0.0e0;
    pre_next_yy = 1.0;
    equationSolving_step_initialize();
    return TRUE;
}

static void equationSolving_step_initialize()
{
    OK = FALSE;
    C_bb = FALSE;
    C_bb1 = FALSE;
    C_d = FALSE;
    C_x2 = FALSE;
    C_err1 = FALSE;
    C_oc = FALSE;
}

EXTERN boolean equationSolving_step()
{
    if (stable)
        {
        if (!r_equationSolving_a(&a)) return FALSE;
        if (!r_equationSolving_b(&b)) return FALSE;
        if (!r_equationSolving_c(&c)) return FALSE;
        OK = a != 0.0;
        C_bb = !OK;
        if (OK)
            {
            bb = b / a;
            dd = bb * bb - 4.0 * (c / a);
            C_d = dd > 0.0;
            C_x2 = dd == 0.0;
            C_err1 = dd < 0.0;
            }
        C_err1_308 = (OK ? C_err1 : FALSE);
        if (C_bb)
            {
            C_err2 = b == 0.0;
            C_bb1 = !(b == 0.0);
            if (C_err2)
                {
                err2 = c != 0.0;
                }
            }
        C_err2_269 = (C_bb ? C_err2 : FALSE);
        C_oc = C_err1_308 || C_err2_269;
        if (C_oc)
            {
            if (C_err1_308) oc = TRUE; else oc = err2; 
            w_equationSolving_oc(oc);
            }
        }
    OK_262 = (stable ? OK : FALSE);
    C_bb1_278 = (C_bb ? C_bb1 : FALSE);
    C_d_289 = (OK ? C_d : FALSE);
    if (C_d_289)
        mx = dd;
    C_x2_300 = (OK ? C_x2 : FALSE);
    if (C_d_289) biterate = TRUE; else biterate = !stable; 
    if (C_d_289) yy = dd / 2.0; else yy = pre_next_yy; 
    if (biterate) next_yy = (yy + mx / yy) / 2.0; else next_yy = yy; 
    XZX_158 = next_yy - yy;
    if (XZX_158 >= 0.0) s = XZX_158; else s = -XZX_158; 
    next_stable = s < (0.00001);
    C_x1 = next_stable && biterate;
    C_a1 = C_x1 || C_x2_300;
    C_x1_338 = C_a1 || C_bb1_278;
    if (C_x1)
        {
        x2 = -((bb - yy) / 2.0);
        w_equationSolving_x2(x2);
        }
    if (C_a1)
        {
        if (C_x1) a1 = -((bb + yy) / 2.0); else a1 = -bb / 2.0; 
        }
    if (C_x1_338)
        {
        if (C_a1) x1 = a1; else x1 = -(c / b); 
        w_equationSolving_x1(x1);
        }
    equationSolving_step_finalize();
    return TRUE;
}

EXTERN boolean equationSolving_step_finalize()
{
    stable = next_stable;
    C_err2 = FALSE;
    pre_next_yy = next_yy;
    equationSolving_step_initialize();
    return TRUE;
}

