process equationSolving =
     ( ? real a;
         real b;
         real c;
       ! real x2;
         real x1;
         boolean error;
     )
   (| (| (| OK := a/=0.0
          | OK_1 := OK
          |) where boolean OK; end
       | (| SecondDegree_ABS(a, b, c) |)/ C_y
                                        / stable
                                        / C_err
                                        / C_bb
                                        / OK
                                        / C_x21
       | (| OK := OK_1
          | FirstDegree(not OK, b, c)
          |) where boolean OK; end
       | (| a2 := x
          | err1 := err
          | a1 := x21
          | (| u := a1 default a2
             | error := (when err1) default err2
             |)
          | x1 := u
          |) where real u, a1, a2;
                   boolean err1; end
       | a ^= b ^= c
       |)/ err2, x, err, x21, OK_1 |)
   where 
   constant real cst_epsilon = 0.0001;
   boolean err2, err, C_x, C_bb, C_err, stable, C_OK, OK, C_y, C_error, C_cc1, OK_1, C_x21;
   process FirstDegree =
        ( ? boolean Compute;
            real b;
            real c;
          ! real x;
            boolean err2;
        )
      (| (| (| (| c := cc_2
                | b := bb_1
                | (| bb := b when (b/=0.0)
                   | cc := c when (b/=0.0)
                   | x := -(cc/bb)
                   |)
                |)/ cc, bb |) where real b, c; end
          | (| c := cc_2
             | b := bb_1
             | error := (c/=0.0) when (b=0.0)
             | err2 := error
             |) where boolean error;
                      real b, c; end
          | (| (| bb := b when Compute
                | cc := c when Compute
                |)
             | bb_1 := bb
             | cc_2 := cc
             |) where real bb, cc; end
          |)/ cc_2, bb_1 |)
      where 
      real bb, cc, bb_1, cc_2;
      end
   ; 
   process SecondDegree_ABS =
        ( ? real a, b, c;
          ! boolean err;
            real x21, x2;
            boolean stable, C_bb, OK, C_err, C_x21;
        )
        spec (| (| {a, b, c} --> {err, x21, x2}
                 | {{a, b, c} --> C_bb} when C_bb
                 | {a --> OK} when OK
                 | {{a, b, c} --> C_err} when C_err
                 | {{a, b, c} --> C_x21} when C_x21
                 |)
              | (| stable ^= C_bb ^= C_x21
                 | when stable ^= a ^= b ^= c ^= OK
                 | when C_bb ^= x2
                 | when OK ^= C_err
                 | when C_err ^= err
                 | when C_x21 ^= x21
                 |)
              |)
      pragmas 
         BlackBox "SecondDegree"
      end pragmas
      external "C"
   ; 
   real x21, x;
   end
; 
