
/*****************************************
 *    SIMULATION DU PASSSAGE A NIVEAU    *
 *****************************************/

/* Une modification du graphique peut induire une modification dans le programme SIGNAL */
#include<X11/StringDefs.h>
#include<X11/Intrinsic.h>
#include<X11/cursorfont.h>
#include<Xm/MainW.h>
#include<Xm/Form.h>
#include<Xm/DrawingA.h>
#include<Xm/Label.h>
#include<Xm/PushB.h>
#include<Xm/Scale.h>
 
#include <Mrm/MrmAppl.h>
#include <Xm/MessageB.h>
#include <Xm/BulletinB.h>

typedef int boolean;
#include "TRAIN_types.h"
#include "TRAIN_externals.h"
 
#define true -1
#define false 0

#define init() TRAIN_initialize()
#define corps() TRAIN_step()

/*** Macros pour projection (modeproj != 1 pour lineaire) ***/

#define modeproj 1

#if modeproj == 1
#      define proj(x) (long)(R*atan((x)/H))
#else
#      define proj(x) ((x)*11./50)
#endif

// s: 1 for line 1, -1 for line 2
#define project(x,s) ((s)>0 ? 550+proj((x)-2500.) : 550-proj((x)-2500.))
#define ht(x) ( ((x)>=0) && ((x)<=1100) ? hauteur[x] : 0)
 
// -- CallBacks
static void pause();
static void reset();
static void init_dessin();
static void finalize();
static void realize_alert();
static void destroy_alert();
static void creat_alert(Widget w);

static void canvas_creat ( Widget w);
static void create_gV1V1 ( Widget w);
static void create_gV2V1 ( Widget w);
static void create_gLV1 ( Widget w);
static void create_gNV1 ( Widget w);
static void create_gV1V2 ( Widget w);
static void create_gV2V2 ( Widget w);
static void create_gLV2 ( Widget w);
static void create_gNV2 ( Widget w);
static void create_sOV1 ( Widget w);
static void create_sCV1 ( Widget w);
static void create_sEV1 ( Widget w);
static void create_sOV2 ( Widget w);
static void create_sCV2 ( Widget w);
static void create_sEV2 ( Widget w);
static void create_gPosB1 ( Widget w);
static void create_gPosB2 ( Widget w);
static void create_gPanMB1 ( Widget w);
static void create_gPanMB2 ( Widget w);
static void create_gPanDB1 ( Widget w);
static void create_gPanDB2 ( Widget w);

static void gere_bouton_rB1 ();
static void gere_bouton_pB1 ();  
static void gere_bouton_dB1 ( ); 
static void gere_bouton_rB2 ( ); 
static void gere_bouton_pB2 (); 
static void gere_bouton_dB2 ( );

static void gere_slider_gV1V1 ( Widget w, caddr_t client, caddr_t appel );
static void gere_slider_gV2V1 ( Widget w, caddr_t client, caddr_t appel );
static void gere_slider_gLV1 ( Widget w, caddr_t client, caddr_t appel );
static void gere_slider_gNV1 ( Widget w, caddr_t client, caddr_t appel );
static void gere_slider_gV1V2 ( Widget w, caddr_t client, caddr_t appel );
static void gere_slider_gV2V2 ( Widget w, caddr_t client, caddr_t appel );
static void gere_slider_gLV2 ( Widget w, caddr_t client, caddr_t appel );
static void gere_slider_gNV2 ( Widget w, caddr_t client, caddr_t appel );
// -- CallBacks End

XtAppContext app_context;
static Pixel xcolor, coul_rouge, coul_fond2, coul_text, coul_fond, coul_bout, coul_fond_voie, coul_fond_board;
/*** Declaration des widgets ***/
static Widget toplevel1,toplevel2, princ_wind, alert_wind, gV1V1, gV2V1, gLV1, gNV1, gV1V2, gV2V2, gLV2, gNV2, 
  sOV1, sCV1, sEV1, sOV2, sCV2, sEV2, gPosB1, gPosB2, gPanMB1, gPanMB2, gPanDB1, gPanDB2;

typedef struct 
{
  Widget w;
  GC  cg;
}  dcanvas;

static dcanvas canvas;

static boolean hgV1V1,hgV2V1,hgLV1,hgNV1, hgV1V2,hgV2V2,hgLV2,hgNV2, hrB1,hpB1,hdB1, hrB2,hpB2,hdB2;
static boolean h2 = true;
static Widget slider[5];/*** Item slider ***/
static boolean b_pause,b_alert;/*** Booleens pour le controle ***/
static char chaine[30]; /*** Chaine de caractere pour les affichages ***/
static int hauteur[1101];/*** Table des hauteurs de wagons ***/
static double R,H;/*** Parametres de la projection ***/
static int tabpos[] = {60,59,56,52,45,38,30,20,10,0}; /*** Tableau pour dessin des barrieres ***/


static void canvas_creat(Widget w) 
{canvas.w=w;} 

static  void create_gV1V1(Widget w)
{ gV1V1=w;} 

static  void create_gV2V1(Widget w)
{ gV2V1=w;} 

static  void create_gLV1(Widget w)
{ gLV1=w;} 

static  void create_gNV1(Widget w)
{ gNV1=w;} 

static  void create_gV1V2(Widget w)
{ gV1V2=w;} 

static  void create_gV2V2(Widget w)
{ gV2V2=w;} 

static  void create_gLV2(Widget w)
{ gLV2=w;} 

static  void create_gNV2(Widget w)
{ gNV2=w;} 

static  void create_sOV1(Widget w)
{ sOV1=w;} 

static  void create_sCV1(Widget w)
{ sCV1=w;} 

static  void create_sEV1(Widget w)
{ sEV1=w;} 

static  void create_sOV2(Widget w)
{ sOV2=w;} 

static  void create_sCV2(Widget w)
{ sCV2=w;} 

static  void create_sEV2(Widget w)
{ sEV2=w;} 

static  void create_gPosB1(Widget w)
{ gPosB1=w;} 

static  void create_gPosB2(Widget w)
{ gPosB2=w;} 

static  void create_gPanMB1(Widget w)
{ gPanMB1=w;} 

static  void create_gPanMB2(Widget w)
{ gPanMB2=w;} 

static  void create_gPanDB1(Widget w)
{ gPanDB1=w;} 

static  void create_gPanDB2(Widget w)
{    
   gPanDB2=w;
}


static void gere_bouton_rB1()
{  
   hrB1=true;
}
static void gere_bouton_pB1()
{  
   hpB1=true;
}

static void gere_bouton_dB1()
{  
   hdB1=true;
}

static void gere_bouton_rB2()
{  
   hrB2=true;
}

static void gere_bouton_pB2()
{  
   hpB2=true;
}

static void gere_bouton_dB2()
{
   hdB2=true;
}
    
static void gere_slider_gV1V1(Widget w, caddr_t client, caddr_t appel)
{   
   hgV1V1=true;
}
static void gere_slider_gV2V1(Widget w, caddr_t client, caddr_t appel)
{   
   hgV2V1=true;
}

static void gere_slider_gLV1(Widget w, caddr_t client, caddr_t appel)
{   
   hgLV1=true;
}
static void gere_slider_gNV1(Widget w, caddr_t client, caddr_t appel)
{   
   hgNV1=true;
}
static void gere_slider_gV1V2(Widget w, caddr_t client, caddr_t appel)
{   
   hgV1V2=true;
}
static void gere_slider_gV2V2(Widget w, caddr_t client, caddr_t appel)
{   
   hgV2V2=true;
}
static void gere_slider_gLV2(Widget w, caddr_t client, caddr_t appel)
{   
   hgLV2=true;
}
static void gere_slider_gNV2(Widget w, caddr_t client, caddr_t appel)
{   
   hgNV2=true;
}

/* Alert managing : when an error occured during manipilation */
/* -----------------------------------------------------------*/
static void creat_alert(Widget w)
{
  alert_wind=w;
  XtUnmanageChild(XmMessageBoxGetChild(alert_wind,XmDIALOG_HELP_BUTTON));
  XtUnmanageChild(XmMessageBoxGetChild(alert_wind,XmDIALOG_CANCEL_BUTTON));
}

static void destroy_alert(Widget w,caddr_t client,caddr_t appel)
{
  XtUnrealizeWidget(toplevel2);
}

static void  realize_alert()
{
  XBell(XtDisplay(alert_wind),50);
  XtRealizeWidget(toplevel2);
}


static void finalize()
{
  XtDestroyApplicationContext(app_context);
  exit(0);
}


/**********************************
 *   Graphical initialisations    *
 **********************************/

static void init_dessin()
{
  static char dec1[]="Timer line 1 :";
  static char dec2[]="Timer line 2 :";
  int x;
  XGCValues valeurs;

  XClearArea(XtDisplay(canvas.w),XtWindow(canvas.w),0,0,1100, 400,FALSE);   
  XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,0,144,1100,144);
  XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,0,374,1100,374);

  x = project(2480.,1); 
  XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,x,144,x,148);
  x = project(2520.,1);
  XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,x,144,x,148);

  x = project(2480.,-1);
  XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,x,374,x,378);
  x = project(2520.,-1);
  XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,x,374,x,378);

  XFillRectangle(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,498,72,16,16);
  XFillRectangle(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,498,302,16,16);

  XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,520,20,520,80);
  XDrawLine(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,520,250,520,310);

  XDrawString(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,10, 200,dec1,strlen(dec1));
  XDrawString(XtDisplay(canvas.w),XtWindow(canvas.w),canvas.cg,10, 220,dec2,strlen(dec2));

}

void init_voie()
{
  XtVaSetValues(gV1V1,XtNvalue,0,NULL);
  XtVaSetValues(gV2V1,XtNvalue,0,NULL);
  XtVaSetValues(gV1V2,XtNvalue,0,NULL);
  XtVaSetValues(gV2V2,XtNvalue,0,NULL);
  XtVaSetValues(gLV1,XtNvalue,10,NULL);
  XtVaSetValues(gNV1,XtNvalue,10,NULL);
  XtVaSetValues(gLV2,XtNvalue,10,NULL);
  XtVaSetValues(gNV2,XtNvalue,10,NULL); 
}


void init_controle()
{
  XtVaSetValues(sOV1,XtNbackground,0,NULL);
  XtVaSetValues(sCV1,XtNbackground,0,NULL);  
  XtVaSetValues(sEV1,XtNbackground,0,NULL);
  XtVaSetValues(sOV2,XtNbackground,0,NULL);  
  XtVaSetValues(sCV2,XtNbackground,0,NULL);
  XtVaSetValues(sEV2,XtNbackground,0,NULL);
  XtVaSetValues(gPosB1,XtNbackground, xcolor,NULL);
  XtVaSetValues(gPanMB1,XtNbackground,0,NULL);
  XtVaSetValues(gPanDB1,XtNbackground,0,NULL);
  XtVaSetValues(gPosB2,XtNbackground, xcolor,NULL);
  XtVaSetValues(gPanMB2,XtNbackground,0,NULL);
  XtVaSetValues(gPanDB2,XtNbackground,0,NULL);
}


static void reset()
{
  hgV1V1 = hgV1V2 = hgV2V1 = hgV2V2 = hgLV1 = hgLV2 = hgNV1 = hgNV2 = false;
  hrB1 = hrB2 = false;
  hpB1 = hpB2 = hdB1 = hdB2 = false;

  init_voie();
  init_controle(); 
  init_dessin();

  init();
}

static void pause()
{
  b_pause = ! b_pause;
}


static  void instant(void *p, unsigned long *q)
{ 
  if (b_alert) 
    {
      realize_alert();
      reset();
      b_alert = false;
    } 
  
 if (! b_pause) corps(); 

 XtAppAddTimeOut(app_context,1,instant,NULL);  
}



static void InitProjectionParameters()
{
#if modeproj == 1

  int i,u;
  float II;

  printf("Distance of the observer ? ");
  scanf("%lf",&H);  
  if (H <= 0.) H = 100.;

  R = (double)(550./atan(2500./H));

  printf("H = %.2f R = %.2f\n",H,R);

  for (i = 0, II = 0.; i <= 550; i++, II += 1.)
    {
      u = (int) (20.0 * cos(II/R));
      hauteur[550-i] = u;
      hauteur[550+i] = u;
    }
#endif
}

#include "mkwindows.c"
#include "calledBySignalProgram.c"

main()
{
  static unsigned int argc;
  static char *argv[] = {"LEVELCROSSING"};
  XGCValues valeurs;

  
  /* Initialisation des parametres de projection */
  InitProjectionParameters();
  
  argc = 1;
  MrmInitialize();
  toplevel1 = XtVaAppInitialize(&app_context,"LEVELCROSSING",NULL,0,&argc,argv,NULL,NULL);
  colors_init(toplevel1);

  mk_main_window(toplevel1);
  XtRealizeWidget(toplevel1);


 toplevel2 = XtAppCreateShell(NULL,"ERROR",applicationShellWidgetClass,XtDisplay(toplevel1),NULL,0);
 mkAlertWindow(toplevel2);
 XtManageChild(alert_wind);

 /* initialisation du tableau de slider */   
 slider[1] = gV1V1;
 slider[2] = gV1V2;
 slider[3] = gV2V1;
 slider[4] = gV2V2;

 valeurs.line_width = 1;
 XtVaGetValues(canvas.w,XtNforeground,&valeurs.foreground,XtNbackground,&valeurs.background,NULL); 
 canvas.cg = XtGetGC(canvas.w,GCForeground|GCBackground|GCLineWidth,&valeurs);

  reset();

  b_alert = false;
  b_pause = false;
  XtAppAddTimeOut(app_context,1,instant,NULL);  // Associe la boucle SIGNAL au timer 
  /* Donne le controle a Motif */
  XtAppMainLoop(app_context);

}


