
#include<stdio.h>
#include<X11/StringDefs.h>
#include<X11/Intrinsic.h>
#include<X11/cursorfont.h>


#include<Xm/MainW.h>
#include<Xm/Form.h>
#include<Xm/DrawingA.h>
#include<Xm/Label.h>
#include<Xm/PushB.h>
#include<Xm/Scale.h>

#include "graphical_const.h"
#include "appli_decl.h"
#include "EOSCILLO.c"    

/* Declarations liees a X-Windows 
   ------------------------------*/
XtAppContext app_context;

static Widget toplevel, canvas_widget;
static Window canvas_fenetre;
static Display *canvas_ecran;
static GC dgc,dgceff;
static XGCValues values;



static logical vh;
static char chaine[4];
static logical  continuer,premier_tour, vcon;
static int x_pred,y_pred;

void inter_con(void)
{
  vcon = TRUE;
}

logical iter(logical *vh)
{
  if (continuer)
    *vh = OSCILLO_step();
  return(!*vh);
}

static void canvas_creat(Widget widget)
{
  canvas_widget = widget;
}

#include "pacemakerd.c"
#include "mkwindows.c"


main(void)
{
  static int argc;
  static char *argv[] = {"OSCILLO"};

  /*-----------------------------------------------------------------------
   *  initialisations 
   *----------------------------------------------------------------------*/
  vh = TRUE;
  vcon = FALSE;
  paceMakerInit();
  continuer = TRUE;

  chaine[0] = ' ';
  premier_tour = TRUE;
  OSCILLO_initialize();
  OSCILLO_OpenIO();

  /*----------------------------
   *  Creation des fenetres X
   *----------------------------*/
  MrmInitialize();
  argc = 1;
  toplevel = XtVaAppInitialize( &app_context, "OSCILLO", NULL, 0, &argc, argv,NULL,NULL);

  mk_main_window(toplevel);
  XtRealizeWidget(toplevel);

  canvas_ecran = XtDisplay(canvas_widget);
  canvas_fenetre = XtWindow(canvas_widget);
  dgc = XDefaultGC(canvas_ecran,XDefaultScreen(canvas_ecran)); 
  values.function = GXclear;
  dgceff = XtGetGC(canvas_widget,GCForeground|GCBackground|GCFunction|GCLineWidth,&values);

  XtAppAddWorkProc(app_context, (void *)iter,&vh); 
  XtAppMainLoop(app_context);
}


long int convint(float x)
{
  return((int)x);
}

long int mod(long int x, long int n)
{
  return(x % n);
}

/*---------------------------------------------------------------
 *  dessinent un segment de droite
 *--------------------------------------------------------------*/
void WLINE(int x1, int y1, int x2, int y2)
{
  XDrawLine(canvas_ecran,canvas_fenetre,dgc,(long int) x1, (long int) y1, (long int) x2, (long int) y2);
}

void WVLINE(long int x1, long int y1, long int y2)
{
  XDrawLine(canvas_ecran,canvas_fenetre,dgc,x1,y1,x1,y2);
}

void whline(long int x1, long int y1, long int x2)
{
  XDrawLine(canvas_ecran,canvas_fenetre,dgc,x1,y1,x2,y1);
}

void point(long int x, long int y)
{

  if (premier_tour || x<=x_pred)
    {
      XDrawPoint(canvas_ecran,canvas_fenetre,dgc,x,y);
      premier_tour = FALSE;
    }
  else {
    XDrawLine(canvas_ecran,canvas_fenetre,dgc,x_pred,y_pred,x,y);
  }
  x_pred = x;
  y_pred = y;
}

/*---------------------------------------------------------------
 *  noircit un rectangle
 *--------------------------------------------------------------*/
void wbpaint(long int x1, long int y1, long int x2, long int y2)
{
  XPoint tcoord[4];

  tcoord[3].x = tcoord[0].x = x1;
  tcoord[2].x = tcoord[1].x = x2;
  tcoord[3].y = tcoord[2].y = y2;
  tcoord[1].y = tcoord[0].y = y1;
  XFillRectangle(canvas_ecran,canvas_fenetre,dgc,x1,y1,x2-x1+1,y2-y1+1);
}

/*---------------------------------------------------------------
 *  blanchit un rectangle
 *--------------------------------------------------------------*/
void wefface(long int x1, long int y1, long int x2, long int y2)
{
  XClearArea(canvas_ecran,canvas_fenetre,x1,y1,x2-x1+1,y2-y1+1,FALSE);
}

/*----------------------------------------------------
 * efface un vecteur (en fait efface toute la fenetre)
 *---------------------------------------------------*/
logical  EFFACEVECT(void)
{
  int x,y;
  x = CANVAS_WIDTH;
  y = CANVAS_HEIGHT ;
  XClearArea(canvas_ecran,canvas_fenetre,0,0,x,y,FALSE);
  return(TRUE);
}


/*------------------------------------------------------------
 *  affiche des axes dans la fenetre graphique
 *----------------------------------------------------------*/
void axes(logical  b)
{
  int x,y;
  if (b)
    {
      x = CANVAS_WIDTH;
      y = CANVAS_HEIGHT;
      WVLINE((x/2)-1,0,y);
      whline(0,y/2,x);
    }
}

/*----------------------------------------------------------------
 *  affiche un entier dans la fenetre graphique
 *--------------------------------------------------------------*/
void AFFICHER_COMPT(int n)
{
  char chaine[10];

  sprintf(chaine,"%d",n);
  XDrawString(canvas_ecran,canvas_fenetre,dgc,20,350,chaine,strlen(chaine));
}
