/* 
   Authors: Loïc Besnard, Patricia Bournai, Thierry Gautier, Paul Le Guernic.
   Copyright (C) by INRIA-CNRS - developed by Espresso project - GPL v2 License - 2010.

   Contact: polychronycontact@listes.irisa.fr 

   This file is part of Polychrony Signal Toolbox (http://www.irisa.fr/espresso/polychrony).

   Polychrony  Signal Toolbox is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License Version 2 as published by the Free
   Software Foundation.

   Polychrony Signal Toolbox is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License Version 2
   for more details.

   You should have received a copy of the GNU General Public License Version 2
   along with Polychrony Signal Toolbox; see the file COPYING. If not, consult the url 
    http://www.gnu.org/licenses/gpl-2.0.html, or write to the Free
   Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA. 
*/
#ifdef __cplusplus
extern "C" {
#endif
  boolean iterateSimu();
  void initSimu();
  int createFrame(int x, int y);
  int createPanel(int father,int position);
  int createPanelWithCustomLayout(int father,int layout);
  int createButton(int num);
  int createLabel(int num);
  int createCanvas(int num,int x, int y);
  int createTextArea(int num ,int x, int y);
  int createSlider(int num,int min, int max, int defaut,int x, int y, int tickDisplay);
  int createCheckBox(int num, int state);
  int createBorder(int num,int x, int y);
  void setTextArea(int numArea,int valeur);
  int readButton(int numButton);
  int readSlider (int numSlider);
  int readCheckBox (int numCheckBox);
  void drawLine(int numCanvas, int x1, int y1, int y2, int vcolor);
  void clearCanvas(int numCanvas, int x1,int dx,int dy);
  void fillRect(int numCanvas, int x,int y,int dx,int dy, int vcolor);
  void drawInteger(int numCanvas, int ch,int x,int y);
  void drawReal(int numCanvas, double ch,int x,int y);
  void quitAppli(void);
  int getColor (int R, int G, int B, int brightness);
#ifdef __cplusplus
}
#endif
