
#include "FIFO_types.h"
#include "FIFOManager.h"

/*#include "FIFO_SendQueue.h"
#include "FIFO_ReceiveQueue.h"
#include "PRIORITY_SendQueue.h"
#include "PRIORITY_ReceiveQueue.h"
*/


#define EQNAME(ELEM,NAME) (strcmp((((ELEM->getValue()).ptrFIFO)-> vfifo)->name, NAME) == 0)

/*****************************************   FIFO OBJECT  *********************************************/

FIFO::FIFO(ptFIFO_type b):vfifo(b){}

/***************************************  FIFO MANAGER_NODE  *****************************************/

FIFOManagerNode::FIFOManagerNode(FIFOAssoc_type value):next(NULL)
{
  contents.FIFOID = value.FIFOID;
  contents.ptrFIFO = value.ptrFIFO;
}

FIFOManagerNode::FIFOManagerNode(){}

FIFOManagerNode::~FIFOManagerNode(){}

void FIFOManagerNode::setValue(FIFOAssoc_type value)
{
  contents.FIFOID = value.FIFOID;
  contents.ptrFIFO = value.ptrFIFO;
}

void FIFOManagerNode::setNext(ptFIFOManagerNode ptvalue)
{ next = ptvalue;}

FIFOAssoc_type FIFOManagerNode::getValue()
{ return contents;}

ptFIFOManagerNode FIFOManagerNode::getNext()
{ return next;}

/*************************************  FIFO MANAGER  **********************************/

 FIFOManager::FIFOManager(int size):first(NULL),last(NULL),max_size(size),current_size(0){}

 FIFOManager::FIFOManager():first(NULL),last(NULL),max_size(MAX_NUMBER_OF_FIFOS),current_size(0){}

 FIFOManager::~FIFOManager(){}

void FIFOManager::setFirst(ptFIFOManagerNode ptvalue)
{ first = ptvalue; }

void FIFOManager::setLast(ptFIFOManagerNode ptvalue)
{ last = ptvalue; }

ptFIFOManagerNode FIFOManager::getFirst()
{ return first; }

ptFIFOManagerNode FIFOManager::getLast()
{ return last; }

bool FIFOManager::FIFORecord(pK_String FIFO_Name, int FIFO_Size, int message_Size, Data_type default_msg, ID_type& FIFOID)
{
  if ( current_size >= max_size) return false;

  current_size++;

  ptFIFOAssoc_type new_record;
  new_record = new  FIFOAssoc_type();
  new_record->FIFOID = current_size;
  
  ptFIFO_type vFIFO;
  vFIFO = new FIFO_type();
  strcpy(vFIFO->name, FIFO_Name); 
  vFIFO->size = FIFO_Size;
  vFIFO->nbmsg = 0;
  
  ptFIFO x = new FIFO(vFIFO);
  new_record->ptrFIFO = x; // new FIFO(vFIFO);
  
  FIFOID = current_size;
  ptFIFOManagerNode new_node = new FIFOManagerNode(*new_record);
  if (first == NULL)
    first = new_node; 
  else
    {
      ptFIFOManagerNode iter = first;
      while ( iter != last ) iter = iter->getNext();
      last->setNext(new_node);
    };
  last = new_node;
  return true;
}


bool FIFOManager::FIFOCheckName(pK_String FIFOName, ID_type& FIFOID)
{
  bool retour;
  ptFIFOManagerNode iter;

  FIFOID = NULL;
  if (first == NULL) return false;
  
  iter = first;
  while ( iter != NULL ) 
    { 
      if (EQNAME(iter,FIFOName)) 
	{
	  FIFOID = (iter->getValue()).FIFOID;
	  return true;
	}
      iter = iter->getNext();
    }
  return false;
}

bool FIFOManager::FIFOCheckID(ID_type FIFOID, FIFO_type& FIFO)
{
  if (first == NULL) return false;

  ptFIFOManagerNode iter = first;

  while ( iter != NULL ) 
    {
      if ( ((iter->getValue()).FIFOID == FIFOID))
	{
	  FIFO = *((last->getValue()).ptrFIFO)->vfifo;
	  return true;
	}
      iter = iter->getNext();
    };
  return false;
}

void FIFOManager::FIFOUpdate(ID_type FIFOID, FIFO_type FIFO)
{
  int b;
  ptFIFO_type x;
  pK_String name;
  ptFIFOManagerNode iter;
  
  fprintf( stderr, "FIFOUpdate \n");fflush(stderr);
  if (first != NULL)
    {
      iter = first;
      strcpy(name, FIFO.name);

      while ( iter != NULL)
	if (EQNAME(iter, name))
	  {
	    x = (((iter->getValue()).ptrFIFO)->vfifo);// warning : side effect on the selected FIFO.
	    for (int i =0; i < MAX_FIFO_SIZE ; i++) x->fifo_queue[i] = FIFO.fifo_queue[i];
	    x->nbmsg = FIFO.nbmsg;
	    iter =NULL;
	  }
	else
	  iter = iter->getNext();
    }
}
