module AADL_CONNECTION =

use AADL_TYPE;
use AADL_PROPERTY;

process Connection =
{type item_type;}
(? item_type write_data; event Latency_time_event;
 ! item_type read_data;)
  pragmas
       Comment "a process that represents the connection between two AADL processes. These two AADL processes bound to different processors. A memory AT() is used to model the latency delay of the connection."
               "@parameter item_type: type of write_data and read_data"
               "@input write_data: write data of connection"
               "@input Latency_time_event: event of latency time"
               "@output read_data: the value of write_date at the event of Latency_time_event"
     end pragmas
(| read_data := AT(write_data, Latency_time_event)
 |)

;
  
% process Connection_old = 
{integer min_offset, max_offset}
(? event Latency_Time, unit1, unit2; input;
 ! output;)
(| Reference_Time := when ^input
 | Between{min_offset, max_offset}(Latency_Time, Reference_Time, unit1, unit2)
 | output := Transmisson(input, Latency_Time)
 |)
where
  event Reference_Time;
end;%
  
  
end;
  

