module AADL_EVENTDATAPORT =

use FIFOS_LIB;

% At Frozen_time_event, frozen current elements of in_fifo to frozen_fifo, 
 the thread can access the frozen_fifo each time when a dequeue action is performed, 
 dequeue_number is constraint in the property%
process InEventDataPort_Behavior =
  { type msg_type;
    msg_type def_value; 
    integer size, dequeue_number; 
    string port_name;}
  (? msg_type write_flow;
     event Frozen_time_event;
   ! msg_type read_flow;)
  (| (out1, cnt1) := fifo{msg_type, size, def_value}(write_flow)
   | cnt1 ^= write_flow ^+ out1
   | out1 ^= Frozen_time_event
   | read_flow := ((out1 when ((cnt1 cell ^read_flow) >0)) cell ^read_flow) when ^read_flow
   |)
where
  shared integer cnt1;
  msg_type out1;
end;


% The output is queued, and sent out at Output_time_event.%
process OutEventDataPort_Behavior =
  { type msg_type;
    msg_type def_value;
    integer size; 
    string port_name;
    }
  (? msg_type write_flow;  
     event Output_time_event;
   !  msg_type sent_flow;)
  (| (out1, cnt1) := fifo{msg_type, size, def_value}(write_flow)
   | out1 ^= Output_time_event
   | cnt1 ^= write_flow ^+ out1
   | sent_flow := ((out1 when ((cnt1 cell Output_time_event) >0)) cell Output_time_event) when Output_time_event
   |)  
  where
    msg_type out1;
    integer cnt1;  
  end;    
end;
