module AADL_EVENTPORT =

use fifoLib;


%  Modified by Loic Besnard %

%--------------------------------------------------------------------------------%


%at Frozen_time_event, frozen current elements of in_fifo to frozen_fifo, 
 the thread can access the frozen_fifo each time when a dequeue action is performed, 
 dequeue_number is constraint in the property%

process InEventPort_Behavior =
  { integer size, dequeue_number; 
    string port_name;}
  (? boolean write_flow;
     event Frozen_time_event;
   ! boolean read_flow;)
  (| (out1, cnt1) := fifo{boolean, size, false}(when write_flow)                %in_fifo%
   | cnt1 ^= write_flow ^+ out1 
   | out1 ^= Frozen_time_event
   | read_flow := ((cnt1 cell ^read_flow) >0) when ^read_flow
   |)

  where
  integer cnt1;
  boolean out1;
end;


%--------------------------------------------------------------------------------%

%the output is queued, and sent out at Output_time_event%

process OutEventPort_Behavior =
{ integer size; 
  string port_name;
  }
(?  boolean write_flow;  
    event Output_time_event;
 !  boolean sent_flow;)
  (| (outy, cnty) := fifo{boolean, size, false}(when write_flow)
   | outy ^= Output_time_event
   | cnty ^= write_flow ^+ outy 
  %  | sent_flow := outy when Output_time_event%
   | sent_flow := ((cnty cell ^Output_time_event) >0) when ^Output_time_event
   | )
   where
     boolean outy;
     integer cnty;
   end;

end;
