module AADL_TYPE =

%use AADL_MSGTYPE;%

type Time_Units = enum (ps, ns, us, ms, sec, min, hr); %predefined type for time units%
type Supported_Dispatch_Protocols = enum (Periodic, Sporadic, Aperiodic, Timed, Hybrid, Background); %predefined type for supported dispatch protocols%
type Timing = enum (sampled, immediate, delayed); %predefined type for Timing property values%
type Fan_Out_Policy = enum (Broadcast, RoundRobin, Selective, OnDemand); %predefined type for Fan_Out_Policy, for possible values are given in AADLv2%
type Dequeue_Protocol = enum (OneItem, MultiItems, AllItems);
type Queue_Processing_Protocol = enum (FIFO, FILO);
type Overflow_Handling_Protocol = enum (DropOldest, DropNewest, Error);
type Input_Time_Reference_Time = enum (Dispatch, Start, Completion, Deadline, NoIO);
type Output_Time_Reference_Time = enum (Dispatch, Start, Completion, Deadline, NoIO);

type CTL1 = bundle (event Dispatch; event Resume; event Deadline; event Initialize;); %bundle type for control signals as input of a thread%
type CTL2= bundle (event Complete; event Error;); %bundle type for control signals as output of a thread%
type SharedData_TIME = bundle (event TRead; event TWrite; event TReset;); %bundle for Shared data read/write/reset time% 

% constant integer MAX_QUEUE_SIZE = 30; constant integer DEFAULT_MSG = 9999;%

type ID_type = integer;
type ReturnCode_type = boolean;


end;
