module SIGNALLIB =

use AADL_TYPE;


process AT = 
(? i; event h; 
 ! o;)
  pragmas
       Comment "a Signal process that represents an input is memorized at the time instants of event h"
               "@input i: input of the memory"
               "@input h: event of memory"
               "@output o: the lastest value of i when h is present"
     end pragmas
  (| o := (i cell h) when h
   |);


process Typed_AT =
{type item_type;}
(? item_type input; event h;
 ! item_type output;)
  pragmas
       Comment "a Signal process that represents an input (type of item_type) is memorized at the time instants of event h"
               "@parameter item_type: type of input/output"
               "@input input: input of the memory"
               "@input h: event of memory"
               "@output output: the lastest value of input when h is present"
     end pragmas
( | output := (input cell h) when h
  |);


end;
